<?php
/**
 * @package n3tTemplate
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

$app = &JFactory::getApplication();
$lang = &JFactory::getLanguage();
$lang->load('com_n3ttemplate',JPATH_ADMINISTRATOR);

$db = & JFactory::getDBO();
$db->execute('UPDATE `#__components` SET `link`="" WHERE `option`="com_n3ttemplate"');

$status = new JObject();
$status->modules = array();
$status->plugins = array();
$status->extra = array();
$status->texts = array();

$src = $this->parent->getPath('source');
$trg = $this->parent->getPath('extension_administrator');

$new_installation = !JFile::exists($trg.DS.'install'.DS.'install.check.php');
if ($new_installation) {
  JFile::copy($src.DS.'install'.DS.'install.check.php',$trg.DS.'install'.DS.'install.check.php');
  $status->texts['ok'] = JText::_('COM_N3TTEMPLATE_INSTALL_INSTALLED');  
  $status->texts['ko'] = JText::_('COM_N3TTEMPLATE_INSTALL_NOT_INSTALLED');
} else {
  $status->texts['ok'] = JText::_('COM_N3TTEMPLATE_INSTALL_UPDATED');  
  $status->texts['ko'] = JText::_('COM_N3TTEMPLATE_INSTALL_NOT_UPDATED');
}

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {
	foreach ($modules->children() as $module) {
		$name = $module->attributes('module');
		$client = $module->attributes('client');
		if(is_null($client)) $client = 'site';
		$position = $module->attributes('position');
		if(is_null($position)) $position = $client == 'site' ? 'left' : 'n3ttemplate.cpanel';
		$ordering = $module->attributes('ordering');
		if(is_null($ordering)) $ordering = '99';
		$path = $src.DS.'modules'.DS.$name;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->modules[] = array('name'=>$name, 'client' => $client, 'position' => $position, 'result'=>$result);
		
    $query = "UPDATE #__modules SET position=".$db->Quote($position).", ordering=".$db->Quote($ordering).", published=1 WHERE module=".$db->Quote($name);
    $db->setQuery($query);
    $db->query();				
	}
}

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {
	foreach ($plugins->children() as $plugin) {
		$name = $plugin->attributes('plugin');
		$group = $plugin->attributes('group');
		$path = $src.DS.'plugins'.DS.$group.DS.$name;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->plugins[] = array('name'=>$name, 'group'=>$group, 'result'=>$result);

		$query = "UPDATE #__plugins SET published=1 WHERE element=".$db->Quote($name)." AND folder=".$db->Quote($group);
		$db->setQuery($query);
		$db->query();
	}
}

$elements = &$this->manifest->getElementByPath('joomfish');
if (is_a($elements, 'JSimpleXMLElement') && count($elements->children())) {
  $result = false;
  if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomfish'.DS.'contentelements')) {
		$result = true;
		foreach ($elements->children() as $element) {
			$result = JFile::copy($src.DS.'admin'.DS.'contentelements'.DS.$element->data(),JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.$element->data()) && $result;
		}
  }
  $status->extra[] = array('name'=>'Joom!Fish content elements', 'result'=>$result);
}

if ($new_installation) {
  $demo = &$this->manifest->getElementByPath('demo');
  if (is_a($demo, 'JSimpleXMLElement') && count($demo->children())) {  
    $result = $this->parent->parseSQLFiles($this->manifest->getElementByPath('demo/sql'));
    $status->extra[] = array('name'=>JText::_('COM_N3TTEMPLATE_INSTALL_DEMO_DATA'), 'result'=>$result);
  }  
}
?>

<?php $k = 0;?>
<img src="components/com_n3ttemplate/assets/images/icon-48-n3ttemplate.png" width="48" height="48" alt="n3tTemplate" align="right" />
<h2><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_INSTALL_HEADING'); ?></h2>
<h3><?php echo $new_installation ? JText::_('COM_N3TTEMPLATE_INSTALL_INSTALL_NEW_INSTALLATION') :JText::_('COM_N3TTEMPLATE_INSTALL_INSTALL_UPGRADE'); ?></h3>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_EXTENSION'); ?></th>
			<th width="30%"><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_STATUS'); ?></th>
		</tr>
	</thead>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo 'n3tTemplate '.JText::_('COM_N3TTEMPLATE_INSTALL_COMPONENT'); ?></td>
			<td><strong style="color: green;"><?php echo $status->texts['ok']; ?></strong></td>
		</tr>
		<?php if (count($status->modules)) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_MODULE'); ?></th>
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_CLIENT'); ?></th>
			<th>&nbsp;</th>
		</tr>
		<?php foreach ($status->modules as $module) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo $module['client']; ?></td>
			<td><strong style="color: <?php echo ($module['result']) ? 'green' : 'red' ?>;"><?php echo ($module['result']) ? $status->texts['ok'] : $status->texts['ko']; ?></strong></td>
		</tr>
		<?php } ?>
		<?php } ?>
		<?php if (count($status->plugins)) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_PLUGIN'); ?></th>
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_GROUP'); ?></th>
			<th>&nbsp;</th>
		</tr>
		<?php foreach ($status->plugins as $plugin) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<td class="key"><?php echo $plugin['name']; ?></td>
			<td class="key"><?php echo $plugin['group']; ?></td>
			<td><strong style="color: <?php echo ($plugin['result']) ? 'green' : 'red' ?>;"><?php echo ($plugin['result']) ? $status->texts['ok'] : $status->texts['ko']; ?></strong></td>
		</tr>
		<?php } ?>
		<?php } ?>
		<?php if (count($status->extra)) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<th colspan=2><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_EXTRA'); ?></th>			
			<th>&nbsp;</th>
		</tr>
		<?php foreach ($status->extra as $extra) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<td class="key" colspan="2"><?php echo $extra['name']; ?></td>			
			<td><strong style="color: <?php echo ($extra['result']) ? 'green' : 'red' ?>;"><?php echo ($extra['result']) ? $status->texts['ok'] : $status->texts['ko']; ?></strong></td>
		</tr>
		<?php } ?>
		<?php } ?>
	</tbody>
</table>
