<?php
/**
 * @package n3tTemplate
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

$lang = &JFactory::getLanguage();
$lang->load('com_n3ttemplate');

$status = new JObject();
$status->modules = array ();
$status->plugins = array ();

$modules = & $this->manifest->getElementByPath('modules');
$plugins = & $this->manifest->getElementByPath('plugins');

if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module) {
		
		$name = $module->attributes('module');
		$client = $module->attributes('client');
		$result = false;
		if(is_null($client)) $client = 'site';		
		$db = & JFactory::getDBO();
		$query = "SELECT `id` FROM `#__modules` WHERE module = ".$db->Quote($name)."";
		$db->setQuery($query);
		$modules = $db->loadResultArray();
		if (count($modules)) {
			foreach ($modules as $module) {
				$installer = new JInstaller;
				$result = $installer->uninstall('module', $module, $client == 'site' ? 0 : 1);
			}
		}
		$status->modules[] = array ('name'=>$name, 'client'=>$client, 'result'=>$result);
	}
}

if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {
		
		$name = $plugin->attributes('plugin');
		$group = $plugin->attributes('group');
		$result = false;
		$db = & JFactory::getDBO();
		$query = 'SELECT `id` FROM #__plugins WHERE element = '.$db->Quote($name).' AND folder = '.$db->Quote($group);
		$db->setQuery($query);
		$plugins = $db->loadResultArray();
		if (count($plugins)) {
			foreach ($plugins as $plugin) {
				$installer = new JInstaller;
				$result = $installer->uninstall('plugin', $plugin, 0);
			}
		}
		$status->plugins[] = array ('name'=>$name, 'group'=>$group, 'result'=>$result);
	}
}

if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomfish'.DS.'contentelements')){
	$elements = &$this->manifest->getElementByPath('joomfish/files');
	if (is_a($elements, 'JSimpleXMLElement') && count($elements->children())) {
		foreach ($elements->children() as $element) {
			if(JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.$element->data()))
				JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.$element->data());
		}
	}
}

?>

<?php $rows = 0;?>
<h2><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_UNINSTALL_HEADING'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_EXTENSION'); ?></th>
			<th width="30%"><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_STATUS'); ?></th>
		</tr>
	</thead>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo 'n3tTemplate '.JText::_('COM_N3TTEMPLATE_INSTALL_COMPONENT'); ?></td>
			<td><strong style="color: green;"><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_REMOVED'); ?></strong></td>
		</tr>
		<?php if (count($status->modules)) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_MODULE'); ?></th>
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_CLIENT'); ?></th>
			<th>&nbsp;</th>
		</tr>
		<?php foreach ($status->modules as $module) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong style="color: <?php echo ($module['result']) ? 'green' : 'red' ?>;"><?php echo ($module['result'])?JText::_('COM_N3TTEMPLATE_INSTALL_REMOVED'):JText::_('COM_N3TTEMPLATE_INSTALL_NOT_REMOVED'); ?></strong></td>
		</tr>
		<?php } ?>
		<?php } ?>
		
		<?php if (count($status->plugins)) { ?>
		<tr class="row<?php echo (++$k % 2); ?>">
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_PLUGIN'); ?></th>
			<th><?php echo JText::_('COM_N3TTEMPLATE_INSTALL_GROUP'); ?></th>
			<th>&nbsp;</th>
		</tr>
		<?php foreach ($status->plugins as $plugin) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong style="color: <?php echo ($plugin['result']) ? 'green' : 'red' ?>;"><?php echo ($plugin['result'])?JText::_('COM_N3TTEMPLATE_INSTALL_REMOVED'):JText::_('COM_N3TTEMPLATE_INSTALL_NOT_REMOVED'); ?></strong></td>
		</tr>
		<?php } ?>
		<?php } ?>
	</tbody>
</table>
